using System;
using System.Windows.Forms;
using System.Text;
using AnnotationPro.Plugin;
using AnnotationPro.Logic;
using AnnotationPro.Presentation;

namespace AnnotationPro.Plugin {
  
  public class AnnotationPlugin : IAnnotationPlugin {
    
    public void Run( AnnotationEditor editor ) {
      // BEGIN USER CODE

      // skrt do Annotation, annotation (z malej litery) jest skrtem
      Annotation annotation = editor.Synchronizer.DataServer.Annotation;

      LayerObject layerSrc = null;
      LayerObject layerDst = null;

      foreach ( LayerObject layer in annotation.Layers ) {
        if ( layer.Name == "F1" ) {
          layerSrc = layer;
        }

        if ( layer.Name == "stimuli_F1" ) {
          layerDst = layer;
        }
      }

      if ( layerSrc == null || layerDst == null ) {
        Info( "Nie znaleziono warstw");
        return;
      }

      // czyszczenie Parameter1 we wszystkich segmentach w warstwie layerDst, 
      // tylko jeden parametr, a nie wszystkie trzy
      foreach ( SegmentObject segDst in layerDst.Segments ) {
        segDst.Parameter1 = string.Empty;
     }

      foreach ( SegmentObject segmentSrc in layerSrc.Segments ) {
        foreach ( SegmentObject segmentDst in layerDst.Segments ) {
          if ( (segmentDst.Start > segmentSrc.Start && segmentDst.Start < segmentSrc.End) ||
            (segmentDst.End > segmentSrc.Start && segmentDst.End < segmentSrc.End) ||
            (segmentSrc.Start >= segmentDst.Start && segmentSrc.End <= segmentDst.End)
            ) {
            if ( segmentDst.Parameter1 != string.Empty ) {
              segmentDst.Parameter1 += "+";
            }
            segmentDst.Parameter1 += segmentSrc.Label;
          }
        }
      }
      annotation.IsModified=true;
     editor.SaveAnnotation();     

      editor.Refresh();

      // END USER CODE
    }

    public void Info( string infoText ) {
      MessageBox.Show( infoText, "Annotation Pro Plugin" );
    }

  }
}