using System;
using System.Windows.Forms;
using System.Text;
using AnnotationPro.Plugin;
using AnnotationPro.Logic;
using AnnotationPro.Presentation;

namespace AnnotationPro.Plugin
{
  public class AnnotationPlugin : IAnnotationPlugin
  {
    public void Run( AnnotationEditor editor )
    {
      // BEGIN USER CODE
      // editor.Synchronizer - synchronization object (cursor position, play, stop, selection)
      // editor.Synchronizer.DataServer.Audio - audio object
      // editor.Synchronizer.DataServer.Annotation.Layers - collection of annotation layers objects

      // EXAMPLE 
      // LayerObject layer = editor.Synchronizer.DataServer.Annotation.Layers.AddNewLayer();
      // if(layer==null) return;
      // layer.Name = "My new layer";

      // SegmentObject segment = new SegmentObject(1000,350,"New segment");
      // layer.Segments.Add(segment);
      
      // skrt do Annotation, annotation jest skrtem
      Annotation annotation = editor.Synchronizer.DataServer.Annotation; 
         
      
     LayerObject layer = editor.SelectedLayer;

     foreach (LayerObject l in annotation.Layers)
     {
         if (l.Name == "stimuli_F1")
             layer = l;
     }
     
      if(layer == null){
          MessageBox.Show("Nie znaleziono zaznaczonej warstwy","Annotation Pro Plugin");
          return;          
      }
      
      // wyliczanie sredniej Parametru1
      foreach (SegmentObject seg in layer.Segments){
        if(seg.Parameter1 == string.Empty) continue;
        double sum = 0; 
        double count = 0;
        string[] vals = seg.Parameter1.Split('+');
        foreach(string val in vals){
          double v = double.Parse(val);
          sum += v;
          count++;
        }
        double avg = sum/count;
        seg.Parameter3 = avg.ToString();
      }
      
      annotation.IsModified=true;
      editor.SaveAnnotation();     
         
     editor.Refresh(); 
      
     // editor.Cursor = Cursors.WaitCursor;

     // MessageBox.Show("Plugins are in 'MyDocuments\\Annotation Pro\\Plugins' folder. See 'Example Plugin.cs' for an example.","Annotation Pro Plugin");
      
     // editor.Cursor = Cursors.Default;
      
      // END USER CODE
    }
  }
}